from odoo import SUPERUSER_ID, api  # type: ignore[import-untyped]


def migrate(cr, _installed_version):
    """Remove user without access to messages from general channel"""
    env = api.Environment(cr, SUPERUSER_ID, {})
    general_channel = env.ref("mail.channel_all_employees")
    if general_channel:
        members_to_remove = env["discuss.channel.member"]
        for member in env.ref("mail.channel_all_employees").channel_member_ids:
            users = env["res.users"].search([("partner_id", "=", member.partner_id.id)])
            for user in users:
                if not user.has_group("mail_messaging_group.group_messaging"):
                    members_to_remove |= member
        if members_to_remove:
            members_to_remove.unlink()
